unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Shlobj,
  StdCtrls, FoldrDlg,  ExtCtrls;

type
  TMainForm = class(TForm)
    btnBrowse: TButton;
    DirectoryEdit: TEdit;
    Label1: TLabel;
    btnClose: TButton;
    RadioGroup1: TRadioGroup;
    TemplateCheckBox: TCheckBox;
    TemplateButton: TButton;
    TemplateRadioButton: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure btnBrowseClick(Sender: TObject);
    procedure CustomButtonClick(Sender: TObject);
  private
    FolderDialog1: TFolderDialog;
    procedure FolderDialog1Show(Sender: TObject);
    procedure FolderDialog1Change(Sender: TObject);
    procedure FolderDialog1Close(Sender: TObject);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

const
  CrLf = chr($D)+chr($A);

procedure TMainForm.btnBrowseClick(Sender: TObject);
begin
  FolderDialog1.Directory:= DirectoryEdit.Text; { fdj}
  if FolderDialog1.Execute then
    DirectoryEdit.Text:=FolderDialog1.Directory;
end;

procedure TMainForm.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
    0:  with FolderDialog1 do
        begin
          CustomButton:= TemplateButton;
          Options:= Options + [bfResizeCustomButton];
        end;
    1:  with FolderDialog1 do
        begin
          CustomButton:= TemplateCheckBox;
          Options:= Options - [bfResizeCustomButton];
        end;
    2:  with FolderDialog1 do
        begin
          CustomButton:= TemplateRadioButton;
          Options:= Options - [bfResizeCustomButton];
        end;
    end;
end;

procedure TMainForm.CustomButtonClick(Sender: TObject);
begin
  with FolderDialog1 do
    if Sender = TemplateButton then RadioGroup1.ItemIndex:= 0
    else
    if Sender = TemplateCheckBox then RadioGroup1.ItemIndex:= 1
    else
    if Sender = TemplateRadioButton then
      RadioGroup1.ItemIndex:= 2;
  RadioGroup1Click(Sender);

  MessageDlg('The properties of the CustomButton in a TFolderDialog'+
    ' are controlled by the properties of a template button. The'+
    ' template button may be invisible and can be assigned to'+
    ' property CustomButton at design-time.'+
    CrLf+CrLf+'This OnClick event is used too.'+
    CrLf+CrLf+'Current directory is ' + FolderDialog1.Directory +
    CrLf+CrLf+'Client = ' +
           IntToStr(FolderDialog1.ClientWidth)+','+
           IntToStr(FolderDialog1.ClientHeight),
    mtInformation,[mbOK],0);
end;

procedure TMainForm.FolderDialog1Show(Sender: TObject);
begin
  ShowMessage('FolderDialog1Show')
end;

procedure TMainForm.FolderDialog1Change(Sender: TObject);
begin
 { with Sender as TFolderDialog do
    ShowMessage('New Selection = '+Directory); }
end;

procedure TMainForm.FolderDialog1Close(Sender: TObject);
begin
  ShowMessage('FolderDialog1Close');
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.Title:= Caption;
  FolderDialog1:= TFolderDialog.Create(Self);
  with FolderDialog1 do
  begin
    { default options are: [bfFileSysDirsOnly, bfStatusText,
         bfShowPathInStatusArea, bfSyncCustomButton,
         bfAlignCustomButton, bfParentCenter] }
    {Options := Options + [bfDontGoBelowDomain, bfScreenCenter];}
    Title := 'Select Directory';
    Text := 'Choose a long path in the shell''s treeview to see how '+
            'next StatusLine is compacted:';
    CustomButton:= TemplateButton;
    OnShow := FolderDialog1Show;
    OnChange := FolderDialog1Change;
    OnClose := FolderDialog1Close;
  end;
end;


end.
